//+------------------------------------------------------------------+
//|                                             Indicator_to_CSV.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Inovance"
#property link      "https://www.inovancetech.com/"
#property description "Save indicator values and OHLC data to a csv file."
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Black
#property indicator_color2 Black

   //Indicator periods


   //Filename
input string   FileName = "CCIRSIdata.csv";
input int Limit_candles = 50;

   //Indicator Buffers
double StochasticBuffer[];
double Casino_HAS_PIN_v3rBuffer[];




//+------------------------------------------------------------------+
//| Initialization function                                          |
//+------------------------------------------------------------------+
int OnInit()
  {
      //Indicator buffers mapping
   SetIndexBuffer(0,StochasticBuffer);   
   SetIndexBuffer(1,Casino_HAS_PIN_v3rBuffer);   
   
      //Indicator styling
    SetIndexStyle(0,DRAW_LINE);  
    SetIndexStyle(1,DRAW_LINE);  
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
      //Define variables
      int limit,i;
      int counted_bars = IndicatorCounted();
      
      //Make sure on most recent bar
      if(counted_bars>0) counted_bars--;
   
      //Set limit
      limit = Limit_candles;
      
      
      //Main loop
      for(i = limit - 1; i>=0; i--) 
         { 
         
         
       
            //Indicators
            StochasticBuffer[i] = iCustom(NULL,0,"Stochastic Slope",8,3,3,0,1,0.05,1,0,i);         
            
            i=i+1;
            Casino_HAS_PIN_v3rBuffer[i] = iCustom(NULL,0,"Casino_HAS_PIN_v3r",false,false,false,false,false,false,true,0,1,0,1,false,20,false,false,0,0,3,Lime,Red,10,DodgerBlue,White,3,0,i);      
            i=i-1;
          
          
            //Create and Open file
            int handle=FileOpen(FileName,FILE_CSV|FILE_READ|FILE_WRITE,",");
            
            //Name column headers
            FileWrite(handle,"Open Timestamp","Open","High","Low","Close","Volume","Stochastic","Casino_HAS_PIN_v3r");
            
            //Go to end of file
            FileSeek(handle,0,SEEK_END);
            
            //Record Indicator values
            FileWrite(handle,Time[i],Open[i],High[i],Low[i],Close[i],Volume[i],StochasticBuffer[i],Casino_HAS_PIN_v3rBuffer[i]);
            
            //Close file
            FileClose(handle);    
            
         }
         
      return(0);
  }